package com.jpattern.core;

import java.util.Map;

import com.jpattern.service.cache.ACacheServiceBuilder;
import com.jpattern.service.log.ALoggerServiceBuilder;
import com.jpattern.service.mail.AMailServiceBuilder;

/**
 * 
 * @author Francesco Cina'
 *
 * 29/gen/2011
 */
public interface ISystem {

	void buildService(IService service);
	
    void buildService(AServiceBuilder serviceBuilder);
    
    void buildLoggerService(ALoggerServiceBuilder loggerServiceBuilder);
    
    void buildMailService(AMailServiceBuilder mailServiceBuilder);
    
    void buildCacheService(ACacheServiceBuilder cacheServiceBuilder );
    
    void remove(String aServiceName);
    
    void removeAllServices();
    
    boolean contains(String aServiceName);

	Map<String, IService> getServiceMap();
}
