package com.jpattern.service.cache.simple;

import java.util.ArrayList;
import java.util.List;

import com.jpattern.service.cache.ACacheServiceBuilder;
import com.jpattern.service.cache.ICache;
import com.jpattern.service.cache.ICacheService;

/**
 * 
 * @author Francesco Cina
 *
 * 23 Sep 2011
 */
public class SimpleCacheServiceBuider extends ACacheServiceBuilder {

	private static final long serialVersionUID = 1L;
	private final List<ICache> caches = new ArrayList<ICache>();

	public SimpleCacheServiceBuider(ICache cache) {
		caches.add(cache);
	}
	
	public SimpleCacheServiceBuider(List<ICache> caches) {
		this.caches.addAll(caches);
	}
	
	@Override
	public ICacheService build() {
		return new SimpleCacheService(getName(), caches);
	}

}
